Golgi_KM_defs = "Golgi_KM.m" ;
autoload ("Golgi_KM" , Golgi_KM_defs) ;
autoload ("Golgi_KM_init" , Golgi_KM_defs) ;
global celsius
celsius = 23;
Golgi_KM_init ;
y0 = Golgi_KM_init (-65) ;
global N ;
N = length (y0) ;
function is = Golgi_KM_currents_odepkg (y)
  global N ;
  global i_KM ;
  t = y (1) ;
  s = y (2:N+1) ;
  y1 = Golgi_KM (t , s) ;
  is = [ t i_KM ] ;
endfunction
function is = Golgi_KM_currents_lsode (y)
  global N ;
  global i_KM ;
  t = y (1) ;
  s = y (2:N+1) ;
  y1 = Golgi_KM (s , t) ;
  is = [ t i_KM ] ;
endfunction
function ys = Golgi_KM_vclamp_run1_odepkg (N , dt , vchold , vchdur , vcbase , vcdur)
  global reltol abstol
  P = odeset ("RelTol" , reltol , "AbsTol" , abstol , "MaxStep" , 1 , "InitialStep" , dt) ;
  t0 = 0.0 ;
  t1 = t0+vchdur ;
  t2 = t1 ;
  t3 = t2+vcdur ;
  t4 = t3 ;
  t5 = t4+vchdur ;
  vinit = vchold ;
  y0 = Golgi_KM_init (vinit)
  sol = ode2r (@Golgi_KM , [ t0 t1 ] , y0 , P) ;
  ys = [ sol.x sol.y ] ;
  vinit = vcbase ;
  y0 = sol.y (size (sol.y) (1) , :) ' ; y0 (1) = vinit
  sol = ode2r (@Golgi_KM , [ t2 t3 ] , y0 , P) ;
  ys = vertcat (ys , [ sol.x sol.y ]) ;
  vinit = vchold ;
  y0 = sol.y (size (sol.y) (1) , :) ' ; y0 (1) = vinit
  sol = ode2r (@Golgi_KM , [ t4 t5 ] , y0 , P) ;
  ys = vertcat (ys , [ sol.x sol.y ]) ;
endfunction ;
function ys = Golgi_KM_vclamp_run1_lsode (N , dt , vchold , vchdur , vcbase , vcdur)
  global reltol abstol
  lsode_options ("absolute tolerance" , abstol) ;
  lsode_options ("relative tolerance" , reltol) ;
  lsode_options ("integration method" , "bdf") ;
  lsode_options ("initial step size" , dt) ;
  t0 = 0.0 ;
  t1 = t0+vchdur ;
  thold0 = linspace (t0 , t1 , (t1-t0) /dt) ;
  t2 = t1 ;
  t3 = t2+vcdur ;
  tclamp = linspace (t2 , t3 , (t3-t2) /dt) ;
  t4 = t3 ;
  t5 = t4+vchdur ;
  thold1 = linspace (t4 , t5 , (t5-t4) /dt) ;
  vinit = vchold ;
  y0 = Golgi_KM_init (vinit)
  y = lsode (@Golgi_KM , y0 , thold0) ;
  ys = [ thold0' y ] ;
  vinit = vcbase ;
  y0 = y (size (y) (1) , :) ' ; y0 (1) = vinit
  y = lsode (@Golgi_KM , y0 , tclamp) ;
  ys = vertcat (ys , [ tclamp' y ]) ;
  vinit = vchold ;
  y0 = y (size (y) (1) , :) ' ; y0 (1) = vinit
  y = lsode (@Golgi_KM , y0 , thold1) ;
  ys = vertcat (ys , [ thold1' y ]) ;
endfunction
function ilog = Golgi_KM_vclamp_fn (N , dt , vchold , vchdur , vcbase , vcdur , vcinc , vcsteps)
  vc = vcbase ;
  ys = cell (1 , vcsteps) ;
  for i = 1:vcsteps
    y = Golgi_KM_vclamp_run1_odepkg (N , dt , vchold , vchdur , vc , vcdur) ;
    ys (i) = y ;
    vc = vc + vcinc ;
  endfor ;
  ilog = cell (vcsteps , 1) ;
  for i = 1:vcsteps
    ilogv = [ ] ;
    n = size (ys {i}) (1) ;
    for j = 1:n
      next = Golgi_KM_currents_odepkg (ys {i} (j , :)) ;
      ilogv = vertcat (ilogv , next) ;
    endfor ;
    ilog {i} = ilogv ;
  endfor ;
endfunction
global reltol abstol
reltol = 1e-03 ;
abstol = 1e-03 ;
dt = 0.001 ;
## i_KM plot
i_KM_index = 2 ;
global comp195_vchold comp195_vchdur comp195_vcbase comp195_vcbdur comp195_vcinc comp195_vcsteps
Golgi_KM_ilog = Golgi_KM_vclamp_fn (N , dt , comp195_vchold , comp195_vchdur , comp195_vcbase , comp195_vcbdur , comp195_vcinc , comp195_vcsteps) ;
subplot (1 , 3 , 1) ;
plot (Golgi_KM_ilog{1}(:,1) , Golgi_KM_ilog{1}(:,i_KM_index) , Golgi_KM_ilog{2}(:,1) , Golgi_KM_ilog{2}(:,i_KM_index) , Golgi_KM_ilog{3}(:,1) , Golgi_KM_ilog{3}(:,i_KM_index) , Golgi_KM_ilog{4}(:,1) , Golgi_KM_ilog{4}(:,i_KM_index) , Golgi_KM_ilog{5}(:,1) , Golgi_KM_ilog{5}(:,i_KM_index) , Golgi_KM_ilog{6}(:,1) , Golgi_KM_ilog{6}(:,i_KM_index) , Golgi_KM_ilog{7}(:,1) , Golgi_KM_ilog{7}(:,i_KM_index) , Golgi_KM_ilog{8}(:,1) , Golgi_KM_ilog{8}(:,i_KM_index)) ;
KM_log = vertcat ([Golgi_KM_ilog{1}(:,1),Golgi_KM_ilog{1}(:,i_KM_index)] , [Golgi_KM_ilog{2}(:,1),Golgi_KM_ilog{2}(:,i_KM_index)] , [Golgi_KM_ilog{3}(:,1),Golgi_KM_ilog{3}(:,i_KM_index)] , [Golgi_KM_ilog{4}(:,1),Golgi_KM_ilog{4}(:,i_KM_index)] , [Golgi_KM_ilog{5}(:,1),Golgi_KM_ilog{5}(:,i_KM_index)] , [Golgi_KM_ilog{6}(:,1),Golgi_KM_ilog{6}(:,i_KM_index)] , [Golgi_KM_ilog{7}(:,1),Golgi_KM_ilog{7}(:,i_KM_index)] , [Golgi_KM_ilog{8}(:,1),Golgi_KM_ilog{8}(:,i_KM_index)]) ;
save -ascii "KM.dat" KM_log ;
