Golgi_SK2_defs = "Golgi_SK2.m" ;
autoload ("Golgi_SK2" , Golgi_SK2_defs) ;
autoload ("Golgi_SK2_init" , Golgi_SK2_defs) ;
global celsius cai
celsius = 23;
cai = 50e-5;
Golgi_SK2_init ;
y0 = Golgi_SK2_init (-65) ;
global N ;
N = length (y0) ;
function is = Golgi_SK2_currents_odepkg (y)
  global N ;
  global i_SK2 ;
  t = y (1) ;
  s = y (2:N+1) ;
  y1 = Golgi_SK2 (t , s) ;
  is = [ t i_SK2 ] ;
endfunction
function is = Golgi_SK2_currents_lsode (y)
  global N ;
  global i_SK2 ;
  t = y (1) ;
  s = y (2:N+1) ;
  y1 = Golgi_SK2 (s , t) ;
  is = [ t i_SK2 ] ;
endfunction
function ys = Golgi_SK2_vclamp_run1_odepkg (N , dt , vchold , vchdur , vcbase , vcdur)
  global reltol abstol
  P = odeset ("RelTol" , reltol , "AbsTol" , abstol , "MaxStep" , 1 , "InitialStep" , dt) ;
  t0 = 0.0 ;
  t1 = t0+vchdur ;
  t2 = t1 ;
  t3 = t2+vcdur ;
  t4 = t3 ;
  t5 = t4+vchdur ;
  vinit = vchold ;
  y0 = Golgi_SK2_init (vinit)
  sol = ode2r (@Golgi_SK2 , [ t0 t1 ] , y0 , P) ;
  ys = [ sol.x sol.y ] ;
  vinit = vcbase ;
  y0 = sol.y (size (sol.y) (1) , :) ' ; y0 (1) = vinit
  sol = ode2r (@Golgi_SK2 , [ t2 t3 ] , y0 , P) ;
  ys = vertcat (ys , [ sol.x sol.y ]) ;
  vinit = vchold ;
  y0 = sol.y (size (sol.y) (1) , :) ' ; y0 (1) = vinit
  sol = ode2r (@Golgi_SK2 , [ t4 t5 ] , y0 , P) ;
  ys = vertcat (ys , [ sol.x sol.y ]) ;
endfunction ;
function ys = Golgi_SK2_vclamp_run1_lsode (N , dt , vchold , vchdur , vcbase , vcdur)
  global reltol abstol
  lsode_options ("absolute tolerance" , abstol) ;
  lsode_options ("relative tolerance" , reltol) ;
  lsode_options ("integration method" , "bdf") ;
  lsode_options ("initial step size" , dt) ;
  t0 = 0.0 ;
  t1 = t0+vchdur ;
  thold0 = linspace (t0 , t1 , (t1-t0) /dt) ;
  t2 = t1 ;
  t3 = t2+vcdur ;
  tclamp = linspace (t2 , t3 , (t3-t2) /dt) ;
  t4 = t3 ;
  t5 = t4+vchdur ;
  thold1 = linspace (t4 , t5 , (t5-t4) /dt) ;
  vinit = vchold ;
  y0 = Golgi_SK2_init (vinit)
  y = lsode (@Golgi_SK2 , y0 , thold0) ;
  ys = [ thold0' y ] ;
  vinit = vcbase ;
  y0 = y (size (y) (1) , :) ' ; y0 (1) = vinit
  y = lsode (@Golgi_SK2 , y0 , tclamp) ;
  ys = vertcat (ys , [ tclamp' y ]) ;
  vinit = vchold ;
  y0 = y (size (y) (1) , :) ' ; y0 (1) = vinit
  y = lsode (@Golgi_SK2 , y0 , thold1) ;
  ys = vertcat (ys , [ thold1' y ]) ;
endfunction
function ilog = Golgi_SK2_vclamp_fn (N , dt , vchold , vchdur , vcbase , vcdur , vcinc , vcsteps)
  vc = vcbase ;
  ys = cell (1 , vcsteps) ;
  for i = 1:vcsteps
    y = Golgi_SK2_vclamp_run1_odepkg (N , dt , vchold , vchdur , vc , vcdur) ;
    ys (i) = y ;
    vc = vc + vcinc ;
  endfor ;
  ilog = cell (vcsteps , 1) ;
  for i = 1:vcsteps
    ilogv = [ ] ;
    n = size (ys {i}) (1) ;
    for j = 1:n
      next = Golgi_SK2_currents_odepkg (ys {i} (j , :)) ;
      ilogv = vertcat (ilogv , next) ;
    endfor ;
    ilog {i} = ilogv ;
  endfor ;
endfunction
global reltol abstol
reltol = 1e-03 ;
abstol = 1e-03 ;
dt = 0.001 ;
## i_SK2 plot
i_SK2_index = 2 ;
global comp220_vchold comp220_vchdur comp220_vcbase comp220_vcbdur comp220_vcinc comp220_vcsteps
Golgi_SK2_ilog = Golgi_SK2_vclamp_fn (N , dt , comp220_vchold , comp220_vchdur , comp220_vcbase , comp220_vcbdur , comp220_vcinc , comp220_vcsteps) ;
subplot (1 , 3 , 1) ;
plot (Golgi_SK2_ilog{1}(:,1) , Golgi_SK2_ilog{1}(:,i_SK2_index) , Golgi_SK2_ilog{2}(:,1) , Golgi_SK2_ilog{2}(:,i_SK2_index) , Golgi_SK2_ilog{3}(:,1) , Golgi_SK2_ilog{3}(:,i_SK2_index) , Golgi_SK2_ilog{4}(:,1) , Golgi_SK2_ilog{4}(:,i_SK2_index) , Golgi_SK2_ilog{5}(:,1) , Golgi_SK2_ilog{5}(:,i_SK2_index) , Golgi_SK2_ilog{6}(:,1) , Golgi_SK2_ilog{6}(:,i_SK2_index) , Golgi_SK2_ilog{7}(:,1) , Golgi_SK2_ilog{7}(:,i_SK2_index) , Golgi_SK2_ilog{8}(:,1) , Golgi_SK2_ilog{8}(:,i_SK2_index)) ;
SK2_log = vertcat ([Golgi_SK2_ilog{1}(:,1),Golgi_SK2_ilog{1}(:,i_SK2_index)] , [Golgi_SK2_ilog{2}(:,1),Golgi_SK2_ilog{2}(:,i_SK2_index)] , [Golgi_SK2_ilog{3}(:,1),Golgi_SK2_ilog{3}(:,i_SK2_index)] , [Golgi_SK2_ilog{4}(:,1),Golgi_SK2_ilog{4}(:,i_SK2_index)] , [Golgi_SK2_ilog{5}(:,1),Golgi_SK2_ilog{5}(:,i_SK2_index)] , [Golgi_SK2_ilog{6}(:,1),Golgi_SK2_ilog{6}(:,i_SK2_index)] , [Golgi_SK2_ilog{7}(:,1),Golgi_SK2_ilog{7}(:,i_SK2_index)] , [Golgi_SK2_ilog{8}(:,1),Golgi_SK2_ilog{8}(:,i_SK2_index)]) ;
save -ascii "SK2.dat" SK2_log ;
